| Qore Programming Language - C/C++ Library 1.0.8

Public Member Functions | List of all members
QoreStringValueHelper Class Reference

this class is used to safely manage calls to AbstractQoreNode::getStringRepresentation() when a simple QoreString value is needed, stack only, may not be dynamically allocated More...

`#include <QoreStringNode.h>`

## Public Member Functions
DLLEXPORT | QoreStringValueHelper (const QoreValue n)
| creates the object and acquires a pointer to the QoreString representation of the QoreValue passed
DLLEXPORT | QoreStringValueHelper (const QoreValue n, const QoreEncoding *enc, ExceptionSink *xsink)
| gets the QoreString representation and ensures that it's in the desired encoding More...
DLLEXPORT | ~QoreStringValueHelper ()
| destroys the object and deletes the QoreString pointer being managed if it was a temporary pointer
DLLEXPORT char * | giveBuffer ()
| returns a char* string that the caller owns and must free() More...
DLLEXPORT QoreString * | giveString ()
| returns a copy of the QoreString that the caller owns More...
DLLEXPORT bool | is_temp () const
| returns true if the pointer being managed is temporary
DLLEXPORT const QoreString * | operator* ()
| returns the object being managed More...
DLLEXPORT const QoreString * | operator-> ()
| returns the object being managed More...

## Detailed Description

this class is used to safely manage calls to AbstractQoreNode::getStringRepresentation() when a simple QoreString value is needed, stack only, may not be dynamically allocated

the QoreString value returned by this function is managed safely in an exception-safe way with this class

QoreStringValueHelper str(n);
printf("str='%s'\n", str->getBuffer());

## Constructor & Destructor Documentation

## ◆ QoreStringValueHelper()

DLLEXPORT QoreStringValueHelper::QoreStringValueHelper | ( | const QoreValue | n,
|  | const QoreEncoding * | enc,
|  | ExceptionSink * | xsink
| ) |  |

gets the QoreString representation and ensures that it's in the desired encoding

a Qore-language exception may be thrown if an encoding error occurs

// get a QoreString value from "node" and ensure it's in UTF-8 encoding
QoreStringValueHelper t(node, QCS_UTF8, xsink);
// return if there was an exception converting the encoding to UTF-8
if (*xsink)
return 0;
// use the string value
return new MStringData(t->getBuffer(), MEncoding::M_ASCII);

## Member Function Documentation

## ◆ giveBuffer()

DLLEXPORT char* QoreStringValueHelper::giveBuffer | ( |  | ) |

returns a char* string that the caller owns and must free()

the object is empty after this call

## ◆ giveString()

DLLEXPORT QoreString* QoreStringValueHelper::giveString | ( |  | ) |

returns a copy of the QoreString that the caller owns

the object may be left empty after this call

Returns
  a QoreString pointer owned by the caller

## ◆ operator*()

DLLEXPORT const QoreString* QoreStringValueHelper::operator* | ( |  | ) |

returns the object being managed

Returns
  the object being managed

## ◆ operator->()

DLLEXPORT const QoreString* QoreStringValueHelper::operator-> | ( |  | ) |

returns the object being managed

Returns
  the object being managed

The documentation for this class was generated from the following file:

- include/qore/QoreStringNode.h